#include "..//my_header.h"

int my_quadratic_eq(char *buffer, int fd)
{
    float a, b, c;
    sscanf(buffer, "%f %f %f", &a, &b, &c);

    char *myBuf = (char *)calloc(100, sizeof(char));

    if (a == 0.0)
    {
        myBuf = "the \'a\' value could`t be a zero\n";
        write(fd, myBuf, strlen(myBuf)); // write message to file
        return 0;                        // because is no x
    }
    else if (c == 0.0)
    {
        snprintf(myBuf, strlen(myBuf), "x1 - %f x2 - %f\n", 0.0, -b / a);

        write(fd, myBuf, strlen(myBuf));
        return 2; // два корня
    }
    else if (b == 0.0)
    {
        snprintf(myBuf, strlen(myBuf), "x1 - %f, x2 - %f\n", sqrt(c / a), -sqrt(c / a));

        write(fd, myBuf, strlen(myBuf));
        return 2; // два корня
    }

    float D = pow(b, 2) - 4 * a * c;
    snprintf(myBuf, strlen(myBuf), "D = %f\n", D);
    write(fd, myBuf, strlen(myBuf));

    if (D == 0.0)
    {
        float x = (-b + D) / 2 * a;
        snprintf(buffer, strlen(buffer), "solution has 1 x, cause D == 0\n. X = %f", x);

        write(fd, buffer, strlen(buffer));
        return 1;
    }
    else if (D < 0)
    {
        // D is < 0
        buffer = "no solution, cause D < 0\n";
        write(fd, buffer, strlen(buffer));
        return 0;
    }

    float x1 = (-b + sqrt(D)) / (2 * a);
    float x2 = (-b - sqrt(D)) / (2 * a);

    snprintf(myBuf, 100, "D = %f\nx1 = %f, x2 = %f\n", D, x1, x2);
    write(fd, myBuf, strlen(myBuf));
    close(fd); // closing file - otvet.txt
    return 2;
}

extern char **environ; // извлекаем переменные окружения процесса (environ также объявлена в <unistd.h>)

int main(int argc, char *argv[])
{
    printf("i am child - %u\n", getpid());

    // ? Print all elements
    // for (size_t i = 0; i < argc; i++) // печатаем аргументы командной строки
    // {
    //     printf("argv[%ld] = %s\n", i, argv[i]);
    // }

    char *buffer = argv[0];
    int fd = atoi(argv[1]);

    lseek(fd, 0, SEEK_SET); // сместим курсор файла в начало
    char *new_buffer = (char *)calloc(1, 100);
    read(fd, new_buffer, 100);
    close(fd); // closing file.txt

    if (strcmp(buffer, new_buffer) == 0)
    {
        printf("data from file is ok\n");
        free(new_buffer);

        char *otvet = "otvet.txt";
        mode_t mode = S_IRWXU | S_IRWXG | S_IRWXO | O_RDWR | S_IRWXU;
        fd = creat(otvet, mode);
        int result = my_quadratic_eq(buffer, fd);
        exit(result);
    }

    return -1; // data is not equals
}
