#include "..//my_header.h"

// Задание на сигналы

// TODO: создать программу, которая в бесконечном цикле каждую секунду печатает фразу "Я работаю". Запустить эту программу в терминале и проверить на ней реакцию на сигналы SIGINT, SIGTSTP и SIGQUIT используя необходимые сочетания клавиш.

// TODO: изменить диспозицию сигнала SIGINT. Создать обработчик, который печатает на консоль сообщение: "Не мешай мне работать"

// TODO: изменить диспозицию сигнала SIGQUIT. Установить на него тот же обработчик сигнала

// TODO: модифицировать обработчик сигнала таким образом, чтобы при поступлении сигнала SIGINT он печатал на консоль сообщение: "Не мешай мне работать", а при поступлении SIGQUIT - сообщение "Тебе не прервать меня"

// TODO: Модифицировать обработчик сигнала таким образом, чтобы он срабатывал только один раз (при первом срабатывании возвращалась исходная диспозиция сигнала).

// TODO: создайте второй процесс, который посылает сигнал SIGINT первому процессу (значение id процесса вводятся с клавиатуры). id первого процесса можно узнать в диспетчере задач или использовать функцию getpid. Запустите оба процесса в двух разных терминалах и отправьте сигнал от второго процесса к первому

void handler_signal(int sig) // функция переопределения сигнала
{
    // SIGINT ctrl+c
    // SIGSTP ctrl+z
    // SIGQUIT  ctrl+\    

    switch (sig)
    {
    case SIGINT:
        printf("\ni am working, stop annoy me\n");
        break;
    case SIGQUIT:
        printf("\ni am said - i am working, don`t annoy me\n");
    default:
        break;
    }

    // переопределяет сигнал на то как было раньше, возвращение диспозиции
    signal(SIGINT, SIG_DFL);
    signal(SIGQUIT, SIG_DFL);
}

void signals_main(void)
{
    void (*old_handler_sigint)(int);
    void (*old_handler_sigquit)(int);

    old_handler_sigint = signal(SIGINT, handler_signal);
    old_handler_sigquit = signal(SIGQUIT, handler_signal);

    if (old_handler_sigint == SIG_ERR)
        printf("can`t catch SIGINT\n");

    while (1)
    {
        printf("i am working, it is me %d\n", getpid());
        sleep(1);
    }
}