#include "..//my_header.h"

void write_into_file(int fd, char *buffer)
{
    int count = write(fd, buffer, strlen(buffer));
}

int open_that_file(char *path_file, mode_t mode)
{
    int fd = open(path_file, O_TRUNC | O_RDWR, mode);
    return fd;
}

void for_file_main()
{

    int fd;
    char *path_file = "..//file.txt";
    fd = creat(path_file, __S_IREAD | __S_IWRITE);

    if (fd < 0)
    {
        printf("Creating file: Failed\n");
        printf("Error is: %d\n", errno);
        printf("Error desc: %s\n", strerror(errno));
    }

    mode_t mode = S_IRWXU | S_IRWXG | S_IRWXO;

    fd = open_that_file(path_file, mode);

    if (fd < 0)
    {
        printf("Opening file: Failed\n");
        printf("Error is: %d\n", errno);
        printf("Error desc: %s\n", strerror(errno));
        perror("Cannot open output file\n");
        exit(1);
    }

    char *buffer = "1.0 2.0 -3.0";

    write_into_file(fd, buffer);

    close(fd);

    char *new_buffer = (char *)calloc(1, 100);

    fd = open(path_file, O_RDONLY);

    read(fd, new_buffer, 100);
    close(fd);
    printf("%s\n", new_buffer);
}