#pragma once

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>
#include <math.h>

#include <errno.h> // для errno

// ! File libs

// File
#include <sys/types.h>
#include <sys/stat.h> // содержит флаги режимов доступа (mode)
#include <fcntl.h>    // содержит флаги для открытия файлов (flags)
#include <unistd.h>   // для close() & for process
#include <sys/stat.h>

#include <signal.h>   // signals
#include <stdlib.h>   // for exit
#include <sys/wait.h> // pid wait

// For file working

void write_into_file(int fd, char *buffer);
int open_that_file(char *path_file, mode_t mode);
float quadratic_eq(char *buffer, float x, int fd);

// Signals -_- >>-_-<<

void handler_signal(int sig);
void signals_main(void);

// threads

#include <pthread.h>
