#include "..//my_header.h"

int main(void)
{
    pid_t some_pid, current; // создал пиды

    switch (some_pid = fork())
    {
    case -1:
        // there is error
        perror("Error");
        exit(1);
        break;

    case 0:;
        // аргументы командной строки
        char *child_argv[] = {"1", "2", "3", "cmd args", NULL};

        // аргументы окружения
        char *child_env[] = {"1 = первый",
                             "2 = второй",
                             "3 = третий",
                             "arg env", NULL};

        execve("taker_arg", child_argv, child_env);
        break;

    default:
        // родитель

        printf("i am - %d\n", getpid());
        int status;
        // ! такой вариант дождётся завершения программы
        some_pid = wait(&status); // вернул в status указатель на код
        break;
    }
    return 0;
}