#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

int counter = 0;
pthread_mutex_t mtx = PTHREAD_MUTEX_INITIALIZER;

static void *thread_function(void *arg)
{
    // Критическая секция
    for (size_t i = 0; i < *(int *)arg; i++)
    {
        pthread_mutex_lock(&mtx);
        counter++;
        pthread_mutex_unlock(&mtx);
    }
    return NULL;
}

int main()
{
    // Инициализация Mutex
    pthread_mutex_init(&mtx, NULL);

    int n = 100;
    // Создание потоков
    pthread_t thread1, thread2;
    pthread_create(&thread1, NULL, thread_function, &n);
    pthread_create(&thread2, NULL, thread_function, &n);

    // Ожидание завершения потоков
    pthread_join(thread1, NULL);
    pthread_join(thread2, NULL);

    // Освобождение ресурсов
    pthread_mutex_destroy(&mtx);

    printf("результат %d\n", counter);
    return 0;
}